import { useDemo, useLiveDemo, useParams } from 'dumi';
import { createElement, useEffect } from 'react';
import "./index.less";
var DemoRenderPage = function DemoRenderPage() {
  var _useParams = useParams(),
    id = _useParams.id;
  var _ref = useDemo(id) || {},
    component = _ref.component;
  var _useLiveDemo = useLiveDemo(id),
    liveDemoNode = _useLiveDemo.node,
    liveDemoError = _useLiveDemo.error,
    setSource = _useLiveDemo.setSource;
  var finalNode = liveDemoNode || component && /*#__PURE__*/createElement(component);

  // listen message event for setSource
  useEffect(function () {
    var handler = function handler(ev) {
      if (ev.data.type === 'dumi.liveDemo.setSource') {
        setSource(ev.data.value);
      }
    };
    window.addEventListener('message', handler);
    return function () {
      return window.removeEventListener('message', handler);
    };
  }, [setSource]);

  // notify parent window that compile done
  useEffect(function () {
    if (liveDemoNode || liveDemoError) {
      window.postMessage({
        type: 'dumi.liveDemo.compileDone',
        value: {
          err: liveDemoError
        }
      });
    }
  }, [liveDemoNode, liveDemoError]);
  return finalNode;
};
export default DemoRenderPage;